from General                          import findFormContainer
from SmartCell                        import SmartCell, manage_addSmartCell
from HTMLForm                         import HTMLForm
from SmartTextBlock                   import manage_addSmartTextBlock
from SmartSectionElement              import manage_addSectionElement
from Products.Formulator              import StandardFields
from Products.Formulator.Form         import FormValidationError

import time, string


def manage_addSmartHeaderCellForm(self, REQUEST):
    ''' '''
    root = findFormContainer(self)
    if not hasattr(root, 'edit_SmartHeaderCellForm'):
        form = HTMLForm('edit_SmartHeaderCellForm', 'Edit Form for Smart HeaderCells')
        form.manage_changeProperties(addAction  = 'manage_addSmartHeaderCell',
                                     editAction = 'manage_edit_properties')

        form._setObject('text', StandardFields.StringField(
            "text",
            title         = "Text",
            required      = 0,
            display_width = 40,
            max_length    = 1000) )

        form._setObject('width', StandardFields.StringField(
            "width",
            title         = "Width",
            required      = 0,
            display_width = 5,
            max_length    = 5) )

        root._setObject('edit_SmartHeaderCellForm', form)

    REQUEST.set('mode', 'Add')
    return root.edit_SmartHeaderCellForm.renderMethod(root.edit_SmartHeaderCellForm, REQUEST)
    

def manage_addSmartHeaderCell(self, id='', title='', nextURL='', position=0, REQUEST=None):
    ''' '''

    root = findFormContainer(self)
    if not hasattr(root, 'edit_SmartHeaderCellForm'):
        manage_addSmartHeaderCellForm(self, REQUEST)

    id = manage_addSectionElement(self, SmartHeaderCell, id, title, '', position, REQUEST, 1)

    headerCell = getattr(self, id)

    REQUEST['field_text'] = 'Enter text here'
    blockId = manage_addSmartTextBlock(headerCell, REQUEST=REQUEST, returnId=1)

    for row in self.aq_parent.objectValues('Smart Row'):
        cell = getattr(row, manage_addSmartCell(row, returnId=1))
        manage_addSmartTextBlock(cell, id=blockId, REQUEST=REQUEST)

    if REQUEST:
        return REQUEST.RESPONSE.redirect(nextURL)



class SmartHeaderCell(SmartCell):
    ''' '''

    meta_type = 'Smart Header Cell'

    _properties= ( {'id': 'text', 'type': 'string', 'mode': 'w', 'default': ''},
                   {'id': 'width', 'type': 'string', 'mode': 'w', 'default': ''}, )

    renderText = '''<th width="%(width)s">%(text)s</th>'''


    def getEditHTML(self):
        ''' '''
        dict = {'cellId'      : self.getId(),
                'cellClass'   : self.__class__.__name__,
                'nextURL'     : self.REQUEST['URL'],
                'rowURL'      : self.aq_parent.absolute_url(),
                'position'    : self.aq_parent.get_object_position(self.getId())}
        
        return _editHTML %dict
    

    def render(self, mode='view'):
        ''' '''
        dict = self.__dict__.copy()
        if mode == 'edit':
            dict['text'] = dict['text'] + self.getEditHTML()
        return self.renderText %dict


_editHTML = '''
 <hr width="90%%" align="center" size="1" noshade>
 <a href="%(rowURL)s/manage_addSmartHeaderCellForm?position=%(position)s&nextURL=%(nextURL)s"
   ><img src="misc_/SmartSections/New" border="0" alt="New"></a>
 <a href="%(rowURL)s/%(cellId)s/edit_%(cellClass)sForm/renderMethod?mode=edit&nextURL=%(nextURL)s"
   ><img src="misc_/SmartSections/Edit" border="0" alt="Edit"></a> 
 <a href="%(rowURL)s/manage_delete_column?id=%(cellId)s&nextURL=%(nextURL)s"
   ><img src="misc_/SmartSections/Delete" border="0" alt="Delete"></a> 
 <a href="%(rowURL)s/manage_move_column_left?id=%(cellId)s&nextURL=%(nextURL)s"
   ><img src="misc_/SmartSections/Left" border="0" alt="Move Column Left"></a>
 <a href="%(rowURL)s/manage_move_column_right?id=%(cellId)s&nextURL=%(nextURL)s"
   ><img src="misc_/SmartSections/Right" border="0" alt="Move Column Right"></a> 
'''
