from General                          import findFormContainer
from SmartRow                         import SmartRow
from HTMLForm                         import HTMLForm
from SmartHeaderCell                  import manage_addSmartHeaderCell
from Products.Formulator              import StandardFields
from Products.Formulator.Form         import FormValidationError

import SmartHeaderCell
import time, string


def manage_addSmartHeaderRowForm(self, REQUEST):
    ''' '''
    root = findFormContainer(self)
    if not hasattr(root, 'edit_SmartHeaderRowForm'):
        form = HTMLForm('edit_SmartHeaderRowForm', 'Edit Form for Smart HeaderRows')
        form.manage_changeProperties(addAction  = 'manage_addSmartHeaderRow',
                                     editAction = 'manage_changeProperties')

    return REQUEST.RESPONSE.redirect('../../manage_addSmartHeaderRow')
    

def manage_addSmartHeaderRow(self, id='', title='', nextURL='', position=0, REQUEST=None):
    ''' '''

    header = SmartHeaderRow('Header', 'This is the Header Row')
    self._setObject('Header', header)

    header = getattr(self, 'Header')
    cols = int(self.cols)

    # prepare the width of each column, assuming they have all the same width
    if self.width[-1] == '%':
        cellWidth = int(string.replace(self.width, '%', ''))/cols
        REQUEST['field_width'] = '%i%%' %(cellWidth)
    else:
        cellWidth = int(self.width)/cols
        REQUEST['field_width'] = '%i' %(cellWidth)
        
    for counter in range(cols):
        REQUEST['field_text'] = 'Header %i' %(counter+1)
        manage_addSmartHeaderCell(header, position=counter, REQUEST=REQUEST)

    if REQUEST:
        return self.manage_main(self, REQUEST)


class SmartHeaderRow(SmartRow):
    ''' '''

    meta_type = 'Smart Header Row'

    _meta_types = ({ 'name': 'Smart Header Cell',
                     'action': 'manage_addProduct/SmartSections/manage_addSmartHeaderCellForm'},)

    manage_addSmartHeaderCellForm = SmartHeaderCell.manage_addSmartHeaderCellForm
    manage_addSmartHeaderCell     = SmartHeaderCell.manage_addSmartHeaderCell

    def getEditHTML(self):
        ''' '''
        dict = {'nextURL'     : self.REQUEST['URL'],
                'rowURL'      : self.absolute_url(),
                'position'    : len(self._objects)}

        return _editHTML %dict


    def _manipulate_column(self, operation, id, nextURL='', REQUEST=None):
        ''' '''
        position = self.get_object_position(id)

        for row in self.aq_parent.objectValues():
            id = row.objectIds()[position]
            getattr(row, operation)(id)

        if nextURL:
            return REQUEST.RESPONSE.redirect(nextURL)
        elif REQUEST:
            return self.manage_main(self, REQUEST)


    def manage_move_column_left(self, id, nextURL='', REQUEST=None):
        ''' '''
        return self._manipulate_column('move_object_up', id, nextURL, REQUEST) 


    def manage_move_column_right(self, id, nextURL='', REQUEST=None):
        ''' '''
        return self._manipulate_column('move_object_down', id, nextURL, REQUEST) 


    def manage_delete_column(self, id, nextURL='', REQUEST=None):
        ''' '''
        return self._manipulate_column('_delObject', id, nextURL, REQUEST) 


        
_editHTML = '''
<td>
   <a href="%(rowURL)s/manage_addSmartHeaderCellForm?position=%(position)s&nextURL=%(nextURL)s"
      ><img src="misc_/SmartSections/New" border="0" alt="New Header Cell"></a>
</td>
'''
