from SmartSectionElement              import SmartSectionElement, manage_addSectionElement
from General                          import findFormContainer
from HTMLForm                         import HTMLForm
from Products.Formulator              import StandardFields
from Products.Formulator.Form         import FormValidationError
from OFS.Image                        import Image

import time, string


def manage_addSmartImageForm(self, REQUEST):
    ''' '''
    root = findFormContainer(self)
    if not hasattr(root, 'edit_SmartImageForm'):
        form = HTMLForm('edit_SmartImageForm', 'Edit Form for Smart Images')
        form.enctype = 'multipart/form-data'
        form.manage_changeProperties(addAction  = 'manage_addSmartImage',
                                     editAction = 'manage_edit_properties')

        form._setObject('file', StandardFields.FileField(
            "file",
            title         = "File",
            required      = 1,
            display_width = 40,
            max_length    = 1000) )

        form._setObject('text', StandardFields.StringField(
            "text",
            title         = "Text",
            required      = 0,
            display_width = 40,
            max_length    = 1000) )

        form._setObject('border', StandardFields.IntegerField(
            "border",
            title         = "border",
            required      = 1))

        root._setObject('edit_SmartImageForm', form)

    REQUEST.set('mode', 'Add')
    return root.edit_SmartImageForm.renderMethod(root.edit_SmartImageForm, REQUEST)


def manage_addSmartImage(self, id='', title='', nextURL='', position=0, REQUEST=None):
    ''' '''
    return manage_addSectionElement(self, SmartImage, id, title, nextURL, position, REQUEST)


class SmartImage(Image, SmartSectionElement):
    ''' '''

    meta_type = 'Smart Image'
    icon = 'misc_/SmartSections/Image'

    _properties= ( ( {'id': 'text',     'type': 'string',   'mode': 'w', 'default': '' },
                     {'id': 'border',   'type': 'int',      'mode': 'w', 'default': 0  } )
                   + Image._properties )


    img__init__ = Image.__init__
    elem__init__ = SmartSectionElement.__init__

    def __init__(self, id='', title='', result={}):
        ''' '''
        self.img__init__(id, title, result['file'])
        self.elem__init__(id, title, result)


    def render(self, mode='view'):
        ''' '''
        return self.tag(border=self.border, alt=self.text)


    def __call__(self, mode='view'):
        ''' '''
        return self.render(mode)
    

    __str__ = __call__

