from SmartSectionElement              import SmartSectionElement, manage_addSectionElement
from General                          import findFormContainer
from HTMLForm                         import HTMLForm
from Products.Formulator              import StandardFields
from Products.Formulator.Form         import FormValidationError

import time, string


def manage_addSmartLinkForm(self, REQUEST):
    ''' '''
    root = findFormContainer(self)
    if not hasattr(root, 'edit_SmartLinkForm'):
        form = HTMLForm('edit_SmartLinkForm', 'Edit Form for Smart Links')
        form.manage_changeProperties(addAction  = 'manage_addSmartLink',
                                     editAction = 'manage_edit_properties')

        form._setObject('link', StandardFields.LinkField(
            "link",
            title         = "Link",
            required      = 0,
            display_width = 40,
            max_length    = 1000) )

        form._setObject('check', StandardFields.CheckBoxField(
            "check",
            title         = "Check Link",
            required      = 1,
            default       = 1) )

        form._setObject('linktype', StandardFields.ListField(
            'linktype',
            title='Type of Link',
            default="external",
            size=1,
            items=[('External Link', 'external'),
                   ('Internal Link', 'internal'),
                   ('Relative Link', 'relative')],
            required=1) )

        form._setObject('text', StandardFields.StringField(
            "text",
            title         = "Text",
            required      = 0,
            display_width = 40,
            max_length    = 1000) )

        form._setObject('cssClass', StandardFields.StringField(
            "cssClass",
            title         = "CSS Class",
            required      = 0,
            display_width = 40,
            max_length    = 1000) )

        root._setObject('edit_SmartLinkForm', form)

    REQUEST.set('mode', 'Add')
    return root.edit_SmartLinkForm.renderMethod(root.edit_SmartLinkForm, REQUEST)


def manage_addSmartLink(self, id='', title='', nextURL='', position=0, REQUEST=None):
    ''' '''
    return manage_addSectionElement(self, SmartLink, id, title, nextURL, position, REQUEST)


class SmartLink(SmartSectionElement):
    ''' '''

    meta_type = 'Smart Link'
    icon = 'misc_/SmartSections/Link'

    _properties= ( {'id': 'link',     'type': 'string', 'mode': 'w', 'default': ''      },
                   {'id': 'text',     'type': 'string', 'mode': 'w', 'default': ''      },
                   {'id': 'cssClass', 'type': 'string', 'mode': 'w', 'default': 'header'} )
                   
    renderText = '''--> <a href="%(link)s" class="%(cssClass)s">%(text)s</a>'''





