from OFS.SimpleItem import SimpleItem
from OFS.PropertyManager import PropertyManager
from Products.Formulator.Form         import FormValidationError

import string, time


def manage_addSectionElement(self, objectClass, id='', title='', nextURL='', position=0,
                             REQUEST=None, returnId=0):
    ''' '''
    className = objectClass.__name__
    form = getattr(self, 'edit_%sForm' %className)
    try:
        result = form.validate_all(REQUEST)
    except FormValidationError, e:
            messages = ["Validation error(s)"]
            for error in e.errors:
                messages.append("%s: %s" % (error.field.get_value('title'),
                                            error.error_text))
            message = string.join(messages, "<br>")
            return form.renderMethod(form, REQUEST,
                                     manage_tabs_message=message)


    if not id: id  = str(long(time.time()*1000))
    
    object = objectClass(id, title, result)
    self._setObject(id, object, position=int(position))

    if nextURL:
        REQUEST.RESPONSE.redirect(nextURL)
    elif returnId:
        return id
    elif REQUEST:
        return self.manage_main(self, REQUEST)



class SmartSectionElement(PropertyManager, SimpleItem):
    ''' '''

    manage_options = PropertyManager.manage_options + SimpleItem.manage_options

    _properties = ()

    renderText = ''

    def __init__(self, id, title, values={}, **kw):
        ''' '''

        self.id = id
        self.title = title

        for prop in self._properties:
            if prop['id'] in values.keys():
                self._setPropValue(prop['id'], values[prop['id']])
            elif prop['id'] in kw.keys():
                self._setPropValue(prop['id'], kw[prop['id']])
            elif prop.has_key('default'):
                self._setPropValue(prop['id'], prop['default'])

            
    def manage_edit_properties(self, nextURL='', REQUEST=None):
        ''' '''
        form = getattr(self, 'edit_%sForm' %self.__class__.__name__)
        try:
            result = form.validate_all(REQUEST)
        except FormValidationError, e:
            messages = ["Validation error(s)"]
            for error in e.errors:
                messages.append("%s: %s" % (error.field.get_value('title'),
                                            error.error_text))
            message = string.join(messages, "<br>")
            return form.renderMethod(self, REQUEST, error=message)

        self.manage_changeProperties(result)

        if nextURL:
            return REQUEST.RESPONSE.redirect(nextURL)
        elif REQUEST:
            return form.renderMethod(form, REQUEST, manage_tabs_message=message)


    def __call__(self, mode='view'):
        ''' '''
        return self.renderText %self.__dict__
    

    __str__ = __call__

