# *******************************************************************************
# *
# * SmartObjects is developed by iuveno AG and the SmartObjects community. It can
# * be used under the same terms as Python or Zope. A specific license will be
# * announced after the first release.
# *
# * Note: Please comment all the code you have written or change comments when
# * the functionality changes. Make notes of the new features and posty them to
# * the list or put them on the official SmartObjects Web site. Furthermore,
# * at the end of the day, always make a change log entry in this file, in
# * addition to the CVS comments.
# *
# * File:       SmartObject.py - Defines an object with multiple data sources
# * Maintainer: Stephan Richter (srichter@iuveno-net.de)
# * Changed on: May 29, 2001
# *
# *******************************************************************************

# Change Log:
# (Format: * DD/MM/YYYY (<initals>) - <short description of changes>)
#

import SmartSection, SmartHeader, SmartTextBlock, SmartTable, SmartBox, \
       SmartLink, SmartImage, SmartSeparator

def initialize(context):

    context.registerClass(
        SmartSection.SmartSection,
        constructors=(SmartSection.manage_addSmartSectionForm,
                      SmartSection.manage_addSmartSection),
        )

    SmartSection.initializeElement(
        SmartHeader.SmartHeader,
        constructors=(SmartHeader.manage_addSmartHeaderForm,
                      SmartHeader.manage_addSmartHeader)
        )

    SmartSection.initializeElement(
        SmartTextBlock.SmartTextBlock,
        constructors=(SmartTextBlock.manage_addSmartTextBlockForm,
                      SmartTextBlock.manage_addSmartTextBlock)
        )
    
    SmartSection.initializeElement(
        SmartTable.SmartTable,
        constructors=(SmartTable.manage_addSmartTableForm,
                      SmartTable.manage_addSmartTable)
        )

    SmartSection.initializeElement(
        SmartBox.SmartBox,
        constructors=(SmartBox.manage_addSmartBoxForm,
                      SmartBox.manage_addSmartBox)
        )

    SmartSection.initializeElement(
        SmartLink.SmartLink,
        constructors=(SmartLink.manage_addSmartLinkForm,
                      SmartLink.manage_addSmartLink)
        )

    SmartSection.initializeElement(
        SmartImage.SmartImage,
        constructors=(SmartImage.manage_addSmartImageForm,
                      SmartImage.manage_addSmartImage)
        )

    SmartSection.initializeElement(
        SmartSeparator.SmartSeparator,
        constructors=(SmartSeparator.manage_addSmartSeparatorForm,
                      SmartSeparator.manage_addSmartSeparator)
        )


# load all the icons automatically
import os
from Globals import package_home, ImageFile
misc_ = {}
path = os.path.join(package_home(globals()), 'www/')

for file in os.listdir(path):
    if file[-3:] == 'gif':
        misc_[file[:-4]] = ImageFile('www/%s' %file, globals())
